local VERSION = tonumber(("$Revision: 31244 $"):match("%d+"))

local PitBull = PitBull
local PitBull_Combat = PitBull:NewModule("Combat", "AceEvent-2.0")
local self = PitBull_Combat
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-28 22:10:48 -0400 (Wed, 28 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_Combat:RegisterPitBullChildFrames('combatIcon')

function PitBull_Combat:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "PLAYER_REGEN_ENABLED")
	
	self:ScheduleRepeatingEvent("PitBull_Combat-Update", self.UpdateAllNonWacky, 0.5, self)
end

function PitBull_Combat:PLAYER_REGEN_ENABLED()
	local frame = PitBull:GetUnitFrame('player')
	if frame then
		self:Update('player', frame)
	end
end

function PitBull_Combat:Update(unit, frame)
	local inCombat = UnitAffectingCombat(unit)
	
	if inCombat then
		if not frame.combatIcon then
			frame.combatIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.combatIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
			frame.combatIcon:SetTexCoord(0.5, 1, 0, 0.5)
			PitBull:UpdateLayout(unit)
		end
	else
		if frame.combatIcon then
			frame.combatIcon = delFrame(frame.combatIcon)
			
			PitBull:UpdateLayout(unit)
		end
	end
end

function PitBull_Combat:UpdateAllNonWacky()
	for unit, frame in PitBull:IterateNonWackyUnitFrames() do
		self:Update(unit, frame)
	end
end

function PitBull_Combat:OnUpdateFrame(unit, frame)
	self:Update(unit, frame)
end

function PitBull_Combat:OnClearUnitFrame(unit, frame)
	if frame.combatIcon then
		frame.combatIcon = delFrame(frame.combatIcon)
	end
end

function PitBull_Combat:OnUnknownLayout(unit, frame)
	frame.combatIcon:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, -3)
	frame.combatIcon:SetWidth(18)
	frame.combatIcon:SetHeight(18)
end

wrap(PitBull_Combat, 'Combat')
