local VERSION = tonumber(("$Revision: 31289 $"):match("%d+"))

local PitBull = PitBull
local PitBull_ComboPoints = PitBull:NewModule("ComboPoints", "AceEvent-2.0")
local self = PitBull_ComboPoints
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-29 16:56:58 -0400 (Thu, 29 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_ComboPoints:RegisterPitBullChildFrames('comboText')

function PitBull_ComboPoints:OnEnable()
	local _, class = UnitClass("player")
	if class == "DRUID" then
		self:RegisterBucketEvent("UNIT_DISPLAYPOWER", 0.05)
	end
end

function PitBull_ComboPoints:UNIT_DISPLAYPOWER(units)
	if units.player then
		local frame = PitBull:GetUnitFrame("target")
		if frame and frame.comboText then
			PitBull:RegisterWatchdogFontString(frame.comboText, "target", UnitPowerType("player") == 3 and "[combos]" or "")
		end
	end
end

function PitBull_ComboPoints:OnPopulateUnitFrame(unit, frame)
	if unit == "target" then
		local comboText = newFrame("FontString", frame.overlay, "OVERLAY")
		frame.comboText = comboText
		comboText:SetFontObject(GameFontHighlightSmall)
		comboText:SetNonSpaceWrap(false)
		PitBull:RegisterWatchdogFontString(frame.comboText, "target", UnitPowerType("player") == 3 and "[combos]" or "")
	end
end

function PitBull_ComboPoints:OnClearUnitFrame(unit, frame)
	if frame.comboText then
		frame.comboText = delFrame(frame.comboText)
	end
end

function PitBull_ComboPoints:OnUnknownLayout(unit, frame, combo)
	if frame.manaBar then
		frame.comboText:SetPoint("CENTER", frame.manaBar, "CENTER")
	end
end

wrap(PitBull_ComboPoints, 'ComboPoints')
