local VERSION = tonumber(("$Revision: 31248 $"):match("%d+"))

local PitBull = PitBull
local PitBull_RaidTarget = PitBull:NewModule("RaidTarget", "AceEvent-2.0")
local self = PitBull_RaidTarget
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-28 22:17:24 -0400 (Wed, 28 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_RaidTarget:RegisterPitBullChildFrames('raidTargetIcon')

function PitBull_RaidTarget:OnEnable()
	self:RegisterEvent("RAID_TARGET_UPDATE")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "RAID_TARGET_UPDATE")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED", "RAID_TARGET_UPDATE")
end

function PitBull_RaidTarget:Update(unit, frame)
	local index = GetRaidTargetIndex(unit)
	if index then
		if not frame.raidTargetIcon then
			frame.raidTargetIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.raidTargetIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
			PitBull:UpdateLayout(unit)
		end
		
		SetRaidTargetIconTexture(frame.raidTargetIcon, index)
	else
		if frame.raidTargetIcon then
			frame.raidTargetIcon = delFrame(frame.raidTargetIcon)
			
			PitBull:UpdateLayout(unit)
		end
	end
end

function PitBull_RaidTarget:RAID_TARGET_UPDATE()
	for unit, frame in PitBull:IterateNonWackyUnitFrames() do
		self:Update(unit, frame)
	end
end

function PitBull_RaidTarget:OnUpdateFrame(unit, frame)
	self:Update(unit, frame)
end

function PitBull_RaidTarget:OnClearUnitFrame(unit, frame)
	if frame.raidTargetIcon then
		frame.raidTargetIcon = delFrame(frame.raidTargetIcon)
	end
end

function PitBull_RaidTarget:OnUnknownLayout(unit, frame)
	frame.raidTargetIcon:SetPoint("CENTER", frame, "TOP", 0, -3)
	frame.raidTargetIcon:SetWidth(18)
	frame.raidTargetIcon:SetHeight(18)
end

wrap(PitBull_RaidTarget, 'RaidTarget')
