local VERSION = tonumber(("$Revision: 31235 $"):match("%d+"))

local PitBull = PitBull
local PitBull_Rest = PitBull:NewModule("Rest", "AceEvent-2.0")
local self = PitBull_Rest
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-28 21:23:22 -0400 (Wed, 28 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_Rest:RegisterPitBullChildFrames('restIcon')

function PitBull_Rest:OnEnable()
	self:RegisterEvent("PLAYER_UPDATE_RESTING")
end

function PitBull_Rest:PLAYER_UPDATE_RESTING()
	local frame = PitBull:GetUnitFrame("player")
	if not frame then
		return
	end
	
	local resting = IsResting()
	if resting then
		if not frame.restIcon then
			frame.restIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.restIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
			frame.restIcon:SetTexCoord(0, 0.5, 0, 0.421875)
			
			PitBull:UpdateLayout("player")
		end
	else
		if frame.restIcon then
			frame.restIcon = delFrame(frame.restIcon)
			
			PitBull:UpdateLayout("player")
		end
	end
end

function PitBull_Rest:OnUpdateFrame(unit, frame)
	if unit == "player" then
		self:PLAYER_UPDATE_RESTING()
	end
end

function PitBull_Rest:OnClearUnitFrame(unit, frame)
	if frame.restIcon then
		frame.restIcon = delFrame(frame.restIcon)
	end
end

function PitBull_Rest:OnUnknownLayout(unit, frame)
	if frame.combatIcon then
		frame.restIcon:SetPoint("LEFT", frame.combatIcon, "RIGHT", 4, 0)
	else
		frame.restIcon:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, -3)
	end
	frame.restIcon:SetWidth(18)
	frame.restIcon:SetHeight(18)
end

wrap(PitBull_Rest, 'Rest')
